// socketx.cpp - CSocketNX̊go[W

#include "stdafx.h"
#include "socketx.h"

// #ifdef _DEBUG
// static char BASED_CODE THIS_FILE[] = __FILE__;
// #endif

IMPLEMENT_DYNAMIC(CSocketX, CSocket)

int CSocketX::Send(/*const*/ void *lpBuf, int nBuflen, int nFlags)
{
	int nRet= CSocket::Send(lpBuf, nBuflen, nFlags);
	return nRet;
}


int CSocketX::Send(LPCTSTR lpszStr, UINT uTimeOut, int nFlags )
{
	// ^CAEglw肳Ăꍇ́Aݒ肷
	if (uTimeOut > 0)
		SetTimeOut(uTimeOut);

	// {NX̊֐Ăяo
	int nRet= CSocket::Send(lpszStr, strlen(lpszStr), nFlags);

	// ^CAEglݒ肵Ăꍇ
	if (uTimeOut > 0)
	{
		KillTimeOut();
		
		//삪^CAEgɂȂ
		if (nRet == SOCKET_ERROR)
		{
			if (GetLastError() == WSAEINTR)
				SetLastError(WSAETIMEDOUT);
		}
	}

	return nRet;
}

int CSocketX::Receive(void *lpBuf, int nBuflen, int nFlags)
{
	int nRet = CSocket::Receive(lpBuf, nBuflen, nFlags);
	return nRet;
}

int CSocketX::Receive(CString& str, UINT uTimeOut, int nFlags)
{
	static char szBuf[256];
	memset(szBuf, 0, sizeof(szBuf));

	// ^CAEglw肳Ăꍇ́Aݒ肷
	if (uTimeOut > 0)
		SetTimeOut(uTimeOut);

	// {NX̊֐Ăяo
	int nRet = CSocket::Receive(szBuf, sizeof(szBuf), nFlags);

	// ^CAEglݒ肵Ăꍇ
	if (uTimeOut >0)
	{
		KillTimeOut();
		
		//삪^CAEgɂȂ
		if (nRet == SOCKET_ERROR)
		{
			if (GetLastError() == WSAEINTR)
				SetLastError(WSAETIMEDOUT);
		}
	}

	// CStringQƂݒ肷
	str = szBuf;

	return nRet;
}

BOOL CSocketX::OnMessagePending()
{
	MSG msg;

	// ^C}[bZ[WĎ
	if(::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_NOREMOVE))
	{
		// ̃^CAEglo߂ꍇ
		if (msg.wParam == ((UINT) m_nTimerID))
		{
			// bZ[W폜
			::PeekMessage(&msg, NULL, WM_TIMER, WM_TIMER, PM_NOREMOVE);

			// Ăяo
			CancelBlockingCall();
			return false;
		}
	}

	// {NX̊֐Ăяo
	return CSocket::OnMessagePending();
}

BOOL CSocketX::SetTimeOut(UINT uTimeOut)
{
	m_nTimerID = SetTimer(NULL, 0, uTimeOut, NULL);
	return m_nTimerID;
}

BOOL CSocketX::KillTimeOut()
{
	return KillTimer(NULL, m_nTimerID);
}


				

	